define('editor',["avalon"], function(avalon) {
    function editor(container){
        var currentRange,_parentElem,supportRange = typeof document.createRange === 'function';
        function getCurrentRange() {
            var selection,range,txt=container;
            if(supportRange){
                selection = document.getSelection();
                if (selection.getRangeAt && selection.rangeCount) {
                    range = document.getSelection().getRangeAt(0);
                    _parentElem = range.commonAncestorContainer;
                }
            }else{
                range = document.selection.createRange();
                if(range){
                    _parentElem = range.parentElement();
                }
            }
            if( _parentElem && (avalon.contains(txt, _parentElem) || txt === _parentElem) ){
                parentElem = _parentElem;
                return range;
            }
            return range;
        }
        function saveSelection() {
            currentRange = getCurrentRange();
        }
        this.getRange=function(){
            return currentRange;
        }
        this.insertImage=function(html){
            this.restoreSelection();
            if(document.selection)
                currentRange.pasteHTML(html); 
            else{
                container.focus();
                document.execCommand("insertHtml",false,html);
                currentRange.collapse();
            }
            saveSelection();
        };
        this.restoreSelection=function(){
            if(!currentRange){
                return;
            }
            var selection,range;
            if(supportRange){
                selection = document.getSelection();
                selection.removeAllRanges();
                selection.addRange(currentRange);
            }else{
                range = document.selection.createRange();
                range.setEndPoint('EndToEnd', currentRange);
                if(currentRange.text.length === 0){
                    range.collapse(false);
                }else{
                    range.setEndPoint('StartToStart', currentRange);
                }
                range.select();
            }
        };
        avalon.bind(container,'mouseup',function(e){
            saveSelection();
        });
        avalon.bind(container,'keyup',function(e){
            saveSelection();
        });
    }
    return [editor,avalon];
});